const fs = require('fs');
const path = require('path');
let data = '';
let readerStream = fs.createReadStream(path.resolve(process.cwd(), 'bxPolymer/polymer_override.less'));
let writerStream = fs.createWriteStream(path.resolve(process.cwd(), 'node_modules/bx-plm-components/my-style.html'));
const template1 = '<link rel="import" href="../bx-plm-base/polymer/polymer-element.html"><dom-module id="my-style">\n' +
    '    <template>\n' +
    '        <style lang="less">\n';
const template2 = '\n</style>\n' +
    '    </template>\n' +
    '    <script>\n' +
    '        class MyStyle extends Polymer.Element {\n' +
    '            static get is() {\n' +
    '                return \'my-style\';\n' +
    '            }\n' +
    '\n' +
    '        }\n' +
    '        window.customElements.define(MyStyle.is, MyStyle);\n' +
    '    </script>\n' +
    '</dom-module>';
readerStream.setEncoding('UTF8');

readerStream.on('data', function(chunk) {
    data += chunk;
});

readerStream.on('end',function(){
    writeToHtml(data);
});

readerStream.on('error', function(err){
    let stack = err.stack;
    //文允许文件不存在
    if(stack.indexOf('no such file or directory') !== -1) {
        console.log(err.stack);
    }
});
let writeToHtml = function (data) {
    let finalData = template1 + data + template2;
    writerStream.write(finalData,'UTF8');
// 标记文件末尾
    writerStream.end();

// 处理流事件 --> data, end, and error
    writerStream.on('finish', function() {
        console.log("resolve custom styles finished");
    });
    writerStream.on('error', function(err) {
        console.log(err.stack);
    });
};